// The GameStats class (and thus, all descendants) by default
// doesn't support logging bot activity. Easy solution is to
// throw in a spectator bot that pass msgs back to our stat class
Class UT2k3PySpec Extends MessagingSpectator;

var UT2k3PyStats PyStat;

function InitPlayerReplicationInfo()
{
	Super.InitPlayerReplicationInfo();
	PlayerReplicationInfo.PlayerName="UT2k3PyStatSpec";
}

event ReceiveLocalizedMessage( class<LocalMessage> Message, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject )
{
  Local LocalMessage Msg;
  Msg = Spawn(Message);
  if ((Msg.IsA('GameMessage')))
	  if (Switch == 1)
        if (RelatedPRI_1.bBot)
		{
		  PyStat.ConnectEvent(RelatedPRI_1);
		  if (RelatedPRI_1.TeamID > 0)
          PyStat.GameEvent("TeamChange", string(RelatedPRI_1.Team.TeamIndex), RelatedPRI_1);
		}

  if ((Msg.IsA('GameMessage')))
	  if (Switch == 3)
        if (RelatedPRI_1.TeamID > 0)
          PyStat.GameEvent("TeamChange", string(RelatedPRI_1.Team.TeamIndex), RelatedPRI_1);


  if ((Msg.IsA('xDeathMessage')))
	  if (PyStat.bLogHRMsges)
		  PyStat.Logf2("{'HRMsg':{'TimeStamp':'"$PyStat.Header()$"','Key':'"$PyStat.HRKey()$"','Type':'K','Msg':\""$Msg.GetString(Switch,RelatedPRI_1,RelatedPRI_2,OptionalObject)$"\"}}");
}

event TeamMessage( PlayerReplicationInfo PRI, coerce string S, name Type  )
{
/*  // EXPERIMENTAL
    // Generate fake log entries
    // Mainly used while testing ut2k3pystats development
    // End-users shouldn't be interested in this ;)

  local PlayerReplicationInfo TestPRI;
  if ((S == "TEST UT2K3PYSTATS") && PRI.bAdmin)
  {
     PyStat.Logf2("TEST START"); //adding this line will cause python to exit with an error.
                                 //Avoids parsing the file as a real log
     // StatsInfo
     PyStat.LogStatsInfo();
     // ServerInfo
     PyStat.ServerInfo();
     // StartGame
     PyStat.StartGame();
     // Connect
     TestPRI = spawn(class'PlayerReplicationInfo');
     TestPRI.PlayerName = "TestPlayer_01";
     TestPRI.PlayerID = 1;
     TestPRI.TeamID = 1;
     TestPRI.bAdmin = true;
     TestPRI.bBot = true; //can't set to false since the StatsID logic will fail
     PyStat.ConnectEvent(TestPRI);
     // SpecialGame
     // GameEvent(string GEvent, string Desc, PlayerReplicationInfo Who)
     PyStat.GameEvent("NameChange","TestPlayer_01_NameChange",TestPRI);
     PyStat.GameEvent("TeamChange","0",TestPRI);
     PyStat.GameEvent("Pickup","PickupItem",TestPRI);
     PyStat.GameEvent("flag_dropped","0",TestPRI);
     PyStat.GameEvent("flag_taken","0",TestPRI);
     PyStat.GameEvent("flag_returned_timeout","0",None);
     PyStat.GameEvent("flag_pickup","0",TestPRI);
     PyStat.GameEvent("flag_returned","0",TestPRI);
     PyStat.GameEvent("flag_captured","0",TestPRI);
     PyStat.GameEvent("bomb_dropped","255",TestPRI);
     PyStat.GameEvent("bomb_taken","255",TestPRI);
     PyStat.GameEvent("bomb_pickup","255",TestPRI);
     PyStat.GameEvent("bomb_returned_timeout","255",None);

     PyStat.Logf2("TEST END");
     return;
  } */
  if (PyStat.bLogChats)
    if (S == (PRI.PlayerName$" logged in as a server administrator."))
      if (PRI.bAdmin) {
        PyStat.Logf2("{'HRMsg':{'TimeStamp':'"$PyStat.Header()$"','Key':'"$PyStat.HRKey()$"','Type':'S','Msg':'"$S$"'}}");
        return;
      }
    PyStat.Logf2("{'HRMsg':{'TimeStamp':'"$PyStat.Header()$"','Key':'"$PyStat.HRKey()$"','Type':'TM','Msg':\"<"$PRI.PlayerName$"> "$S$"\"}}");
}

function ClientVoiceMessage(PlayerReplicationInfo Sender, PlayerReplicationInfo Recipient, name messagetype, byte messageID)
{
}

defaultproperties
{
}
